.*------------------------------------------------------------------------------
.* iODBC (OS/2) - SQLDisconnect
.* (c) 1997 by Dirk Ohme - all rights reserved
.*------------------------------------------------------------------------------

.*------------------------------------------------------------------------------
.*   'SQLDisconnect'
.*------------------------------------------------------------------------------
:h2 id=cli_SQLDisconnect clear.SQLDisconnect
:xmp.
  RETCODE SQL_API SQLDisconnect(
                               LPDBC               lpdbc
                               );
:exmp.
:table cols='20 59'.
:row.:c.ODBC            :c.core level
:row.:c.X/Open          :c.yes
:etable.

:p.:hp2.calling parameters:ehp2.
:lm margin=5.:ul.
:li.:hp1.lpdbc:ehp1. - handle to database context
:eul.:lm margin=1.

:p.:hp2.return codes:ehp2.
:table cols='20 10 49'.
:row.:c.return code          :c.:link reftype=hd refid=cli_SQLError.SQLError:elink.:c.comment
:row.:c.SQL_ERROR            :c.08003  :c.no connection established
:row.:c.                     :c.25000  :c.transaction must be ended first
:row.:c.                     :c.58004  :c.can't find path to database
:row.:c.SQL_INVALID_HANDLE   :c.-      :c.invalid handle to database context
:row.:c.SQL_SUCCESS          :c.-      :c.connection successfully closed
:etable.

:p.The purpose of this routine is to close an open connection established by
:link reftype=hd refid=cli_SQLBrowseConnect.SQLBrowseConnect():elink.,
:link reftype=hd refid=cli_SQLConnect.SQLConnect():elink. or
:link reftype=hd refid=cli_SQLDriverConnect.SQLDriverConnect():elink.. After
successful close there can't be any database activities. Before closing, all
open transactions have to be ended (see
:link reftype=hd refid=cli_SQLTransact.SQLTransact():elink.).

.*------------------------------------------------------------------------------
