.*------------------------------------------------------------------------------
.* iODBC (OS/2) - SQLFreeStmt
.* (c) 1997 by Dirk Ohme - all rights reserved
.*------------------------------------------------------------------------------

.*------------------------------------------------------------------------------
.*   'SQLFreeStmt'
.*------------------------------------------------------------------------------
:h2 id=cli_SQLFreeStmt clear.SQLFreeStmt
:xmp.
  RETCODE SQL_API SQLFreeStmt(
          LPSTMT  lpstmt,
          UWORD   fOption);
:exmp.
:table cols='20 59'.
:row.:c.ODBC            :c.core level
:row.:c.X/Open          :c.yes
:etable.

:p.:hp2.calling parameters:ehp2.
:lm margin=5.:ul.
:li.:hp1.lpstmt:ehp1. - handle for statement
:li.:hp1.fOption:ehp1. - option code&colon.:lm margin=10.
:li.:hp2.SQL_CLOSE:ehp2. - close statement (cursor)
:li.:hp2.SQL_DROP:ehp2. - close statement (cursor) and free handle
:li.:hp2.SQL_UNBIND:ehp2. - unbind columns, keep statement
:li.:hp2.SQL_RESET_PARAMS:ehp2. - reset parameters on bind-columns
:eul.:lm margin=1.

:p.:hp2.return codes:ehp2.
:table cols='20 10 49'.
:row.:c.return code          :c.:link reftype=hd refid=cli_SQLError.SQLError:elink.:c.comment
:row.:c.SQL_ERROR            :c.S1092  :c.invalid option :hp1.fOption:ehp1.
:row.:c.SQL_INVALID_HANDLE   :c.-      :c.invalid :hp1.lpstmt:ehp1.
:row.:c.SQL_SUCCESS          :c.-      :c.operation succeeded
:etable.

:p.Depending on the option code :hp1.fOption:ehp1. a statement handle allocated
with :link reftype=hd refid=cli_SQLAllocStmt.SQLAllocStmt():elink. is reseted
in parts or total, or is freed.

.*------------------------------------------------------------------------------
