.*------------------------------------------------------------------------------
.* iODBC (OS/2) - funcs
.* (c) 1997 by Dirk Ohme - all rights reserved
.*------------------------------------------------------------------------------

.*------------------------------------------------------------------------------
.* 'CLI Function Calls'
.*------------------------------------------------------------------------------
:h1 id=cli_function_calls clear.CLI Function Calls
:p.The following chapters and pages deal with the functions provided by this
package. For a better overview have a look at the lists.

:p.:hp2.Catalogue (Tables, Columns, etc.):ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLColumnPrivileges.SQLColumnPrivileges:elink.
:li.:link reftype=hd refid=cli_SQLColumns.SQLColumns:elink.
:li.:link reftype=hd refid=cli_SQLForeignKeys.SQLForeignKeys:elink.
:li.:link reftype=hd refid=cli_SQLPrimaryKeys.SQLPrimaryKeys:elink.
:li.:link reftype=hd refid=cli_SQLProcedureColumns.SQLProcedureColumns:elink.
:li.:link reftype=hd refid=cli_SQLProcedures.SQLProcedures:elink.
:li.:link reftype=hd refid=cli_SQLSpecialColumns.SQLSpecialColumns:elink.
:li.:link reftype=hd refid=cli_SQLStatistics.SQLStatistics:elink.
:li.:link reftype=hd refid=cli_SQLTablePrivileges.SQLTablePrivileges:elink.
:li.:link reftype=hd refid=cli_SQLTables.SQLTables:elink.
:eul.:lm margin=1.

:p.:hp2.Connection to Database:ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLAllocConnect.SQLAllocConnect:elink.
:li.:link reftype=hd refid=cli_SQLAllocEnv.SQLAllocEnv:elink.
:li.:link reftype=hd refid=cli_SQLBrowseConnect.SQLBrowseConnect:elink.
:li.:link reftype=hd refid=cli_SQLConnect.SQLConnect:elink.
:li.:link reftype=hd refid=cli_SQLDisconnect.SQLDisconnect:elink.
:li.:link reftype=hd refid=cli_SQLDriverConnect.SQLDriverConnect:elink.
:li.:link reftype=hd refid=cli_SQLFreeConnect.SQLFreeConnect:elink.
:li.:link reftype=hd refid=cli_SQLFreeEnv.SQLFreeEnv:elink.
:eul.:lm margin=1.

:p.:hp2.Execution of SQL Statements:ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLCancel.SQLCancel:elink.
:li.:link reftype=hd refid=cli_SQLExecDirect.SQLExecDirect:elink.
:li.:link reftype=hd refid=cli_SQLExecute.SQLExecute:elink.
:li.:link reftype=hd refid=cli_SQLNativeSql.SQLNativeSql:elink.
:li.:link reftype=hd refid=cli_SQLParamData.SQLParamData:elink.
:li.:link reftype=hd refid=cli_SQLPutData.SQLPutData:elink.
:eul.:lm margin=1.

:p.:hp2.Information about CLI:ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLGetInfo.SQLGetInfo:elink.
:li.:link reftype=hd refid=cli_SQLGetTypeInfo.SQLGetTypeInfo:elink.
:eul.:lm margin=1.

:p.:hp2.Options:ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLGetConnectOption.SQLGetConnectOption:elink.
:li.:link reftype=hd refid=cli_SQLGetStmtOption.SQLGetStmtOption:elink.
:li.:link reftype=hd refid=cli_SQLSetConnectOption.SQLSetConnectOption:elink.
:li.:link reftype=hd refid=cli_SQLSetStmtOption.SQLSetStmtOption:elink.
:eul.:lm margin=1.

:p.:hp2.Preparation of SQL Statements:ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLAllocStmt.SQLAllocStmt:elink.
:li.:link reftype=hd refid=cli_SQLDescribeParam.SQLDescribeParam:elink.
:li.:link reftype=hd refid=cli_SQLFreeStmt.SQLFreeStmt:elink.
:li.:link reftype=hd refid=cli_SQLGetCursorName.SQLGetCursorName:elink.
:li.:link reftype=hd refid=cli_SQLNumParams.SQLNumParams:elink.
:li.:link reftype=hd refid=cli_SQLParamOptions.SQLParamOptions:elink.
:li.:link reftype=hd refid=cli_SQLPrepare.SQLPrepare:elink.
:li.:link reftype=hd refid=cli_SQLSetCursorName.SQLSetCursorName:elink.
:li.:link reftype=hd refid=cli_SQLSetParam.SQLSetParam:elink.
:li.:link reftype=hd refid=cli_SQLSetScrollOptions.SQLSetScrollOptions:elink.
:eul.:lm margin=1.

:p.:hp2.Results of a SQL Statement:ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLBindCol.SQLBindCol:elink.
:li.:link reftype=hd refid=cli_SQLColAttributes.SQLColAttributes:elink.
:li.:link reftype=hd refid=cli_SQLDescribeCol.SQLDescribeCol:elink.
:li.:link reftype=hd refid=cli_SQLError.SQLError:elink.
:li.:link reftype=hd refid=cli_SQLExtendedFetch.SQLExtendedFetch:elink.
:li.:link reftype=hd refid=cli_SQLFetch.SQLFetch:elink.
:li.:link reftype=hd refid=cli_SQLGetData.SQLGetData:elink.
:li.:link reftype=hd refid=cli_SQLMoreResults.SQLMoreResults:elink.
:li.:link reftype=hd refid=cli_SQLNumResultCols.SQLNumResultCols:elink.
:li.:link reftype=hd refid=cli_SQLRowCount.SQLRowCount:elink.
:li.:link reftype=hd refid=cli_SQLSetPos.SQLSetPos:elink.
:eul.:lm margin=1.

:p.:hp2.Transaction Handling:ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLTransact.SQLTransact:elink.
:eul.:lm margin=1.

:p.:hp2.iODBC driver specific routines:ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLDriverSetup.SQLDriverSetup:elink.
:eul.:lm margin=1.

:p.:hp2.Other calls (portability, compatibility):ehp2.
:lm margin=5.:ul.
:li.:link reftype=hd refid=cli_SQLAllocHandle.SQLAllocHandle:elink.
:li.:link reftype=hd refid=cli_SQLBindParam.SQLBindParam:elink.
:li.:link reftype=hd refid=cli_SQLCloseCursor.SQLCloseCursor:elink.
:li.:link reftype=hd refid=cli_SQLCopyDesc.SQLCopyDesc:elink.
:li.:link reftype=hd refid=cli_SQLEndTran.SQLEndTran:elink.
:li.:link reftype=hd refid=cli_SQLFreeHandle.SQLFreeHandle:elink.
:li.:link reftype=hd refid=cli_SQLGetCol.SQLGetCol:elink.
:li.:link reftype=hd refid=cli_SQLGetConnectAttr.SQLGetConnectAttr:elink.
:li.:link reftype=hd refid=cli_SQLGetDescField.SQLGetDescField:elink.
:li.:link reftype=hd refid=cli_SQLGetDescRec.SQLGetDescRec:elink.
:li.:link reftype=hd refid=cli_SQLGetDiagField.SQLGetDiagField:elink.
:li.:link reftype=hd refid=cli_SQLGetDiagRec.SQLGetDiagRec:elink.
:li.:link reftype=hd refid=cli_SQLGetEnvAttr.SQLGetEnvAttr:elink.
:li.:link reftype=hd refid=cli_SQLGetStmtAttr.SQLGetStmtAttr:elink.
:li.:link reftype=hd refid=cli_SQLLanguages.SQLLanguages:elink.
:li.:link reftype=hd refid=cli_SQLReleaseEnv.SQLReleaseEnv:elink.
:li.:link reftype=hd refid=cli_SQLServerInfo.SQLServerInfo:elink.
:li.:link reftype=hd refid=cli_SQLSetDescField.SQLSetDescField:elink.
:li.:link reftype=hd refid=cli_SQLSetDescRec.SQLSetDescRec:elink.
:li.:link reftype=hd refid=cli_SQLSetEnvAttr.SQLSetEnvAttr:elink.
:li.:link reftype=hd refid=cli_SQLSetStmtAttr.SQLSetStmtAttr:elink.
:eul.:lm margin=1.

.*------------------------------------------------------------------------------
