.*------------------------------------------------------------------------------
.* iODBC (OS/2) - returns
.* (c) 1997 by Dirk Ohme - all rights reserved
.*------------------------------------------------------------------------------

.*------------------------------------------------------------------------------
.* 'CLI Function Return Codes'
.*------------------------------------------------------------------------------
:h1 id=cli_function_return_codes clear.CLI Function Return Codes
:p.Each Call-Level Interface (CLI) function returns a result code, that
shows success or failure of an operation, or if there is additional information
code to be processed.

:table cols='25 54'.
:row.:c.SQL_SUCCESS           :c.operation ended successfully
:row.:c.SQL_SUCCESS_WITH_INFO :c.same, but there is additional information
(see table below)
:row.:c.SQL_NEED_DATA         :c.operation aborted due to lack of data
:row.:c.SQL_NO_DATA           :c.operation failed due to lack of data
:row.:c.SQL_NO_DATA_FOUND     :c.there is no data found
:row.:c.SQL_ERROR             :c.operation failed, see :link reftype=hd
refid=cli_SQLError.SQLError:elink.
:row.:c.SQL_INVALID_HANDLE    :c.invalid handle (
:link reftype=hd refid=sql_data_types.HDBC:elink.,
:link reftype=hd refid=sql_data_types.HDESC:elink.,
:link reftype=hd refid=sql_data_types.HENV:elink.,
:link reftype=hd refid=sql_data_types.HSTMT:elink.
)
:etable.

:note.
The definition :hp2.SQL_SUCCEEDED(:ehp2.:hp4.x:ehp4.:hp2.):ehp2. can be used to
detect whether :hp4.x:ehp4. specifies a return code of a successful operation
or not.

:p.:hp2.Internal error messages and codes:ehp2. (set at :hp1.SQL_ERROR:ehp1.)
:table cols='25 54'.
:row.:c.Code  :c.Message
:row.:c.01004 :c.result string has been truncated
:row.:c.07005 :c.column or result value not available
:row.:c.07006 :c.can't convert C data type into SQL data type
:row.:c.08001 :c.can't connect to server, cannot execute
:row.:c.08002 :c.connection already established
:row.:c.08003 :c.no connection established
:row.:c.08004 :c.can't connect to database
:row.:c.24000 :c.statement handle already in use
:row.:c.25000 :c.transaction must be ended first
:row.:c.34000 :c.invalid cursor name
:row.:c.40003 :c.no connection to database or communication error
:row.:c.58004 :c.ROLLBACK failed or an other internal error
:row.:c.S1001 :c.memory allocation error
:row.:c.S1002 :c.invalid column number
:row.:c.S1003 :c.invalid or unsupported C data type
:row.:c.S1004 :c.invalid SQL data type
:row.:c.S1009 :c.pointer must address a variable and mustn't be NULL
:row.:c.S1010 :c.invalid sequence in function calls
:row.:c.S1012 :c.invalid action code
:row.:c.S1013 :c.can't allocate internal memory
:row.:c.S1090 :c.parameter error (parameter must not be NULL, range error)
:row.:c.S1091 :c.invalid sub-function specified
:row.:c.S1092 :c.invalid option
:row.:c.S1093 :c.invalid parameter number
:row.:c.S1094 :c.invalid value
:row.:c.S1097 :c.invalid column type detected
:row.:c.S1104 :c.invalid value
:row.:c.S1C00 :c.a parameter or result can't be resolved
:etable.

.*------------------------------------------------------------------------------
