.*-----------------------------------------------------------------------------
.* main.ipf
.*-----------------------------------------------------------------------------
.* base file for online documentation
.* (c) 1997 by Dirk Ohme
.*-----------------------------------------------------------------------------

.*---| includes |--------------------------------------------------------------

.*---| document header |-------------------------------------------------------
:userdoc.
:docprof toc=123456.
:title.iODBC V VERSION

.*---| sub-documents |---------------------------------------------------------
#include "source/info.ipf"
#include "source/intro.ipf"

.*---| ... SQL definitions and data types |------------------------------------
#include "source/defs.ipf"
#include "source/data.ipf"

.*---| ... SQL routines |------------------------------------------------------
#include "source/SQL_PROC/funcs.ipf"
#include "source/SQL_PROC/SQLAllocConnect.ipf"
#include "source/SQL_PROC/SQLAllocEnv.ipf"
#include "source/SQL_PROC/SQLAllocHandle.ipf"
#include "source/SQL_PROC/SQLAllocStmt.ipf"
#include "source/SQL_PROC/SQLBindCol.ipf"
#include "source/SQL_PROC/SQLBindParam.ipf"
#include "source/SQL_PROC/SQLBrowseConnect.ipf"
#include "source/SQL_PROC/SQLCancel.ipf"
#include "source/SQL_PROC/SQLCloseCursor.ipf"
#include "source/SQL_PROC/SQLColAttributes.ipf"
#include "source/SQL_PROC/SQLColumnPrivileges.ipf"
#include "source/SQL_PROC/SQLColumns.ipf"
#include "source/SQL_PROC/SQLConnect.ipf"
#include "source/SQL_PROC/SQLCopyDesc.ipf"
#include "source/SQL_PROC/SQLDescribeCol.ipf"
#include "source/SQL_PROC/SQLDescribeParam.ipf"
#include "source/SQL_PROC/SQLDisconnect.ipf"
#include "source/SQL_PROC/SQLDriverConnect.ipf"
#include "source/SQL_PROC/SQLDriverSetup.ipf"
#include "source/SQL_PROC/SQLEndTran.ipf"
#include "source/SQL_PROC/SQLError.ipf"
#include "source/SQL_PROC/SQLExecDirect.ipf"
#include "source/SQL_PROC/SQLExecute.ipf"
#include "source/SQL_PROC/SQLExtendedFetch.ipf"
#include "source/SQL_PROC/SQLFetch.ipf"
#include "source/SQL_PROC/SQLForeignKeys.ipf"
#include "source/SQL_PROC/SQLFreeConnect.ipf"
#include "source/SQL_PROC/SQLFreeEnv.ipf"
#include "source/SQL_PROC/SQLFreeHandle.ipf"
#include "source/SQL_PROC/SQLFreeStmt.ipf"
#include "source/SQL_PROC/SQLGetCol.ipf"
#include "source/SQL_PROC/SQLGetConnectAttr.ipf"
#include "source/SQL_PROC/SQLGetConnectOption.ipf"
#include "source/SQL_PROC/SQLGetCursorName.ipf"
#include "source/SQL_PROC/SQLGetData.ipf"
#include "source/SQL_PROC/SQLGetDescField.ipf"
#include "source/SQL_PROC/SQLGetDescRec.ipf"
#include "source/SQL_PROC/SQLGetDiagField.ipf"
#include "source/SQL_PROC/SQLGetDiagRec.ipf"
#include "source/SQL_PROC/SQLGetEnvAttr.ipf"
#include "source/SQL_PROC/SQLGetInfo.ipf"
#include "source/SQL_PROC/SQLGetStmtAttr.ipf"
#include "source/SQL_PROC/SQLGetStmtOption.ipf"
#include "source/SQL_PROC/SQLGetTypeInfo.ipf"
#include "source/SQL_PROC/SQLLanguages.ipf"
#include "source/SQL_PROC/SQLMoreResults.ipf"
#include "source/SQL_PROC/SQLNativeSql.ipf"
#include "source/SQL_PROC/SQLNumParams.ipf"
#include "source/SQL_PROC/SQLNumResultCols.ipf"
#include "source/SQL_PROC/SQLParamData.ipf"
#include "source/SQL_PROC/SQLParamOptions.ipf"
#include "source/SQL_PROC/SQLPrepare.ipf"
#include "source/SQL_PROC/SQLPrimaryKeys.ipf"
#include "source/SQL_PROC/SQLProcedureColumns.ipf"
#include "source/SQL_PROC/SQLProcedures.ipf"
#include "source/SQL_PROC/SQLPutData.ipf"
#include "source/SQL_PROC/SQLReleaseEnv.ipf"
#include "source/SQL_PROC/SQLRowCount.ipf"
#include "source/SQL_PROC/SQLServerInfo.ipf"
#include "source/SQL_PROC/SQLSetConnectOption.ipf"
#include "source/SQL_PROC/SQLSetCursorName.ipf"
#include "source/SQL_PROC/SQLSetDescField.ipf"
#include "source/SQL_PROC/SQLSetDescRec.ipf"
#include "source/SQL_PROC/SQLSetEnvAttr.ipf"
#include "source/SQL_PROC/SQLSetParam.ipf"
#include "source/SQL_PROC/SQLSetPos.ipf"
#include "source/SQL_PROC/SQLSetScrollOptions.ipf"
#include "source/SQL_PROC/SQLSetStmtAttr.ipf"
#include "source/SQL_PROC/SQLSetStmtOption.ipf"
#include "source/SQL_PROC/SQLSpecialColumns.ipf"
#include "source/SQL_PROC/SQLStatistics.ipf"
#include "source/SQL_PROC/SQLTablePrivileges.ipf"
#include "source/SQL_PROC/SQLTables.ipf"
#include "source/SQL_PROC/SQLTransact.ipf"

.*---| ... SQL return codes, samples, notes |----------------------------------
#include "source/returns.ipf"
#include "source/samples.ipf"
#include "source/iodbc.ipf"
#include "source/limits.ipf"

.*---| ... other stuff |-------------------------------------------------------
#include "source/history.ipf"
#include "source/other.ipf"

.*---| end of document |-------------------------------------------------------
:euserdoc.

.*-----------------------------------------------------------------------------
