/* Copyright Abandoned 1996 TCX DataKonsult AB & Monty Program KB & Detron HB
   This file is public domain and comes with NO WARRANTY of any kind */

/*
** OPTIONS.C - This is the ODBC sample driver code for
** executing Set/GetConnect/StmtOption.
*/


#include "myodbc.h"

RETCODE SQL_API SQLSetConnectOption(HDBC hdbc, UWORD fOption, UDWORD  vParam)
{
  DBUG_ENTER("SQLSetConnectOption");
  DBUG_PRINT("enter",("Option: %d  Param: %ld",fOption,(ulong) vParam));
  if (fOption != SQL_LOGIN_TIMEOUT && fOption != SQL_AUTOCOMMIT)
    DBUG_RETURN(set_error(hdbc,"IM001","This dosn't work yet"));
  DBUG_RETURN(SQL_SUCCESS);
}


RETCODE SQL_API SQLSetStmtOption(HSTMT hstmt,UWORD fOption,UDWORD vParam)
{
  STMT FAR *stmt=(STMT FAR*) hstmt;
  DBUG_ENTER("SQLSetStmtOption");
  DBUG_PRINT("enter",("Option: %d  Param: %ld",fOption,(ulong) vParam));

  switch (fOption) {
   default:
    break;					/* Lie */
  case SQL_MAX_LENGTH:
    stmt->max_length=(ulong) vParam;
    break;
  case SQL_MAX_ROWS:
    stmt->max_rows=(ulong) vParam;
    break;
  }
  DBUG_RETURN(SQL_SUCCESS);
}


RETCODE SQL_API SQLGetConnectOption(HDBC hdbc,UWORD fOption,PTR vParam)
{
  DBUG_ENTER("SQLGetConnectOption");
  DBUG_PRINT("enter",("Option: %d",fOption));
  DBUG_RETURN(set_error(hdbc,"IM001","This dosn't work yet"));
}


RETCODE SQL_API SQLGetStmtOption(HSTMT hstmt,UWORD fOption,PTR vParam)
{
  STMT FAR *stmt=(STMT FAR*) hstmt;
  DBUG_ENTER("SQLGetStmtOption");
  DBUG_PRINT("enter",("Option: %d",fOption));

  switch (fOption) {
   case SQL_BIND_TYPE:
   default:
     DBUG_RETURN(set_error(stmt->dbc,"S1C00","This dosn't work yet"));
     break;
   case SQL_KEYSET_SIZE:		/* Can't be that wrong */
   case SQL_QUERY_TIMEOUT:
     *((ulong*) vParam)=0L;
     break;
   case SQL_NOSCAN:
     *((ulong*) vParam)=SQL_NOSCAN_OFF;
     break;
   case SQL_ASYNC_ENABLE:
     *((ulong*) vParam)=SQL_ASYNC_ENABLE_OFF;
     break;
   case SQL_CURSOR_TYPE:
     *((ulong*) vParam)=SQL_CURSOR_STATIC;
     break;
   case SQL_MAX_LENGTH:
     *((ulong*) vParam)= stmt->max_length;
    break;
   case SQL_MAX_ROWS:
     *((ulong*) vParam)= stmt->max_rows;
     break;
   case SQL_SIMULATE_CURSOR:
     *((ulong*) vParam)= SQL_SC_NON_UNIQUE;
     break;
   case SQL_USE_BOOKMARKS:
     *((ulong*) vParam)=SQL_UB_OFF;
     break;
 }
 DBUG_RETURN(SQL_SUCCESS);
}
