/* Copyright Abandoned 1996 TCX DataKonsult AB & Monty Program KB & Detron HB
   This file is public domain and comes with NO WARRANTY of any kind */

#include "mysys_priv.h"
#include <m_string.h>

	/* Functions definied in this file */

uint dirname_length(name)
const char *name;
{
  register string pos,gpos;
#ifdef FN_DEVCHAR
  if ((pos=strrchr(name,FN_DEVCHAR)) == 0)
#endif
    pos=(char*) name-1;

  gpos= pos++;
  for ( ; *pos ; pos++)				/* Find last FN_LIBCHAR */
    if (*pos == FN_LIBCHAR || *pos == '/'
#ifdef FN_C_AFTER_DIR
	|| *pos == FN_C_AFTER_DIR || *pos == FN_C_AFTER_DIR_2
#endif
	)
      gpos=pos;
  return ((uint) (uint) (gpos+1-(char*) name));
}


	/* Gives directory part of filename. Directory ends with '/' */
	/* Returns length of directory part */

uint dirname(to,name)
string to;
const char *name;
{
  uint length;
  DBUG_ENTER("dirname");
  DBUG_PRINT("enter",("'%s'",name));

  length=dirname_length(name);
  VOID(strmake(to,(char*) name,length));
  convert_dirname(to);				/* Convert chars */
  DBUG_RETURN(length);
} /* dirname */


	/* convert dirname to use under this system */
	/* If MSDOS converts '/' to '\' */
	/* If VMS converts '<' to '[' and '>' to ']' */
	/* Adds a '/' to end if there isn't one and the last isn't a dev_char */
	/* ARGSUSED */

#ifndef FN_DEVCHAR
#define FN_DEVCHAR '\0'				/* For easyer code */
#endif

void convert_dirname(to)
string to;
{
#ifdef FN_UPPER_CASE
  caseup_str(to);
#endif
#if FN_LIBCHAR != '/'
  {
    reg1 string pos;
    pos=to-1;					/* Change from '/' */
    while ((pos=strchr(pos+1,'/')) != 0)
      *pos=FN_LIBCHAR;
  }
#endif
#ifdef FN_C_BEFORE_DIR_2
  {
    reg1 string pos;
    for (pos=to ; *pos ; pos++)
    {
      if (*pos == FN_C_BEFORE_DIR_2)
	*pos=FN_C_BEFORE_DIR;
      if (*pos == FN_C_AFTER_DIR_2)
	*pos=FN_C_AFTER_DIR;
    }
  }
#else
  {					/* Append FN_LIBCHAR if not there */
    char *end=strend(to);
    if (end != to && (end[-1] != FN_LIBCHAR && end[-1] != FN_DEVCHAR))
    {
      end[0]=FN_LIBCHAR;
      end[1]=0;
    }
  }
#endif
} /* convert_dirname */
